(function () { "use strict";
var Example2 = function() { }
Example2.__name__ = true;
Example2.main = function() {
	GDK.loadImage("face.png",1);
	Example2.forcex = Math.random() - 0.5;
	Example2.forcey = Math.random() - 0.5;
	GDK.setMainLoop(Example2.mainLoop);
}
Example2.mainLoop = function() {
	if(GDK.progress() >= 1) {
		var dt = GDK.deltaTime();
		Example2.possx += Example2.forcex * Example2.factor * dt;
		Example2.possy += Example2.forcey * Example2.factor * dt;
		if(Example2.possx < 0) {
			Example2.possx = 0;
			Example2.forcex = Math.abs(Example2.forcex);
		}
		if(Example2.possy < 0) {
			Example2.possy = 0;
			Example2.forcey = Math.abs(Example2.forcey);
		}
		if(Example2.possx > 256) {
			Example2.possx = 256;
			Example2.forcex = -Math.abs(Example2.forcex);
		}
		if(Example2.possy > 128) {
			Example2.possy = 128;
			Example2.forcey = -Math.abs(Example2.forcey);
		}
		GDK.pasteImage(1,Math.floor(Example2.possx),Math.floor(Example2.possy));
	}
}
var GDK = function() { }
GDK.__name__ = true;
GDK.deltaTime = function(max) {
	if(max == null) max = 0.5;
	var now = haxe.Timer.stamp();
	var dt = now - GDK.lastUpdate;
	if(dt > max) dt = max;
	GDK.lastUpdate = now;
	return dt;
}
GDK.setMainLoopMan = function() {
	if(GDK.message == "") {
		GDK.cls();
		GDK.setMainLoopLoop();
	} else {
		GDK.response = js.Browser.window.prompt(GDK.message,GDK.response);
		if(GDK.response == null) GDK.response = "";
		GDK.message = "";
		cancelMouseClick();
	}
}
GDK.setMainLoop = function(loop,framerate) {
	if(framerate == null) framerate = 60;
	GDK.setMainLoopLoop = loop;
	if(GDK.enterFrameSetYet == true) GDK.enterFrameReplacement.stop(); else GDK.enterFrameSetYet = true;
	GDK.enterFrameReplacement = new haxe.Timer(Math.floor(1000 / framerate));
	GDK.enterFrameReplacement.run = GDK.setMainLoopMan;
}
GDK.mouseClick = function() {
	return mouseclick;
}
GDK.mouseX = function() {
	return mousex;
}
GDK.mouseY = function() {
	return mousey;
}
GDK.loadImage = function(name,number) {
	GDK.images[number] = image.loadAny(name);
}
GDK.pasteImage = function(number,positionX,positionY,width,height,sX,sY,sWidth,sHeight,a) {
	var usealpha = 255.0;
	if(width != null && height != null) {
		if(width < 0 || height < 0) {
			ctx.save();
			ctx.scale(width < 0?-1:1,height < 0?-1:1);
			positionX = width < 0?-width - positionX:positionX;
			positionY = height < 0?-height - positionY:positionY;
		}
		if(sX != null && sY != null && sWidth != null && sHeight != null) {
			sWidth = Math.abs(sWidth);
			sHeight = Math.abs(sHeight);
			if(a != null) usealpha = a;
			setAlpha(usealpha);
			ctx.drawImage(GDK.images[number],sX,sY,sWidth,sHeight,positionX,positionY,width,height);
		} else {
			if(sX != null) usealpha = sX;
			setAlpha(usealpha);
			ctx.drawImage(GDK.images[number],positionX,positionY,width,height);
		}
		if(width < 0 || height < 0) ctx.restore();
	} else {
		if(width != null) usealpha = width;
		setAlpha(usealpha);
		ctx.drawImage(GDK.images[number],positionX,positionY);
	}
}
GDK.box = function(x1,y1,x2,y2,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	fillRGBA(r,g,b,a);
	ctx.beginPath();
	ctx.moveTo(x1,y1);
	ctx.lineTo(x2,y1);
	ctx.lineTo(x2,y2);
	ctx.lineTo(x1,y2);
	ctx.fill();
}
GDK.line = function(x1,y1,x2,y2,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	strokeRGBA(r,g,b,a);
	ctx.beginPath();
	ctx.moveTo(x1,y1);
	ctx.lineTo(x2,y2);
	ctx.stroke();
}
GDK.oval = function(x1,y1,x2,y2,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	var centerX = (x1 + x2) * 0.5;
	var centerY = (y1 + y2) * 0.5;
	var xRadius = Math.abs(x2 - centerX);
	var yRadius = Math.abs(y2 - centerY);
	var sides = 64;
	var pi2 = 2 * Math.PI;
	fillRGBA(r,g,b,a);
	ctx.beginPath();
	ctx.moveTo(centerX + xRadius,centerY);
	var _g = 0;
	while(_g < sides) {
		var i = _g++;
		var pointRatio = i / sides;
		var radians = pointRatio * pi2;
		var xSteps = Math.cos(radians);
		var ySteps = Math.sin(radians);
		var pointX = centerX + xSteps * xRadius;
		var pointY = centerY + ySteps * yRadius;
		ctx.lineTo(pointX,pointY);
	}
	ctx.fill();
}
GDK.polygon = function(vlist,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	fillRGBA(r,g,b,a);
	ctx.beginPath();
	var thevert = vlist[0];
	ctx.moveTo(thevert[0],thevert[1]);
	var _g1 = 1, _g = vlist.length;
	while(_g1 < _g) {
		var i = _g1++;
		thevert = vlist[i];
		ctx.lineTo(thevert[0],thevert[1]);
	}
	ctx.fill();
}
GDK.cls = function() {
	ctx.clearRect(0,0,ctx.canvas.width,ctx.canvas.height);
}
GDK.screenWidth = function() {
	return Math.floor(ctx.canvas.width);
}
GDK.screenHeight = function() {
	return Math.floor(ctx.canvas.height);
}
GDK.progress = function() {
	return (soundProgress+image.progress)/(soundCount+image.count);
}
GDK.text = function(positionX,positionY,txt,align,size,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	if(size == null) size = 16;
	if(align == null) align = "left";
	fillRGBA(r,g,b,a);
	superText(Std.string(txt),positionX,positionY,align,size);
}
var Std = function() { }
Std.__name__ = true;
Std.string = function(s) {
	return js.Boot.__string_rec(s,"");
}
var haxe = {}
haxe.Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
haxe.Timer.__name__ = true;
haxe.Timer.stamp = function() {
	return new Date().getTime() / 1000;
}
haxe.Timer.prototype = {
	run: function() {
		console.log("run");
	}
	,stop: function() {
		if(this.id == null) return;
		clearInterval(this.id);
		this.id = null;
	}
}
var js = {}
js.Boot = function() { }
js.Boot.__name__ = true;
js.Boot.__string_rec = function(o,s) {
	if(o == null) return "null";
	if(s.length >= 5) return "<...>";
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) t = "object";
	switch(t) {
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) return o[0];
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2, _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) str += "," + js.Boot.__string_rec(o[i],s); else str += js.Boot.__string_rec(o[i],s);
				}
				return str + ")";
			}
			var l = o.length;
			var i;
			var str = "[";
			s += "\t";
			var _g = 0;
			while(_g < l) {
				var i1 = _g++;
				str += (i1 > 0?",":"") + js.Boot.__string_rec(o[i1],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString) {
			var s2 = o.toString();
			if(s2 != "[object Object]") return s2;
		}
		var k = null;
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) { ;
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) str += ", \n";
		str += s + k + " : " + js.Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "function":
		return "<function>";
	case "string":
		return o;
	default:
		return String(o);
	}
}
js.Browser = function() { }
js.Browser.__name__ = true;
Math.__name__ = ["Math"];
Math.NaN = Number.NaN;
Math.NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
Math.POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
Math.isFinite = function(i) {
	return isFinite(i);
};
Math.isNaN = function(i) {
	return isNaN(i);
};
String.__name__ = true;
Array.__name__ = true;
Date.__name__ = ["Date"];
Example2.possx = 0.0;
Example2.possy = 0.0;
Example2.factor = 200;
GDK.lastUpdate = 0.0;
GDK.message = "";
GDK.response = "";
GDK.enterFrameSetYet = false;
GDK.images = new Array();
js.Browser.window = typeof window != "undefined" ? window : null;
Example2.main();
})();
