function getel(theid){
	if(document.getElementById){
		return document.getElementById(theid);
	}else if(document.all){
		return document.all[theid];
	}else if(document.layers){
		return document.layers[theid];
	}else{
		return function(){};
	}
}

var canv=getel("canv");

var supportcan=0;

if(canv.getContext){
	var ctx=canv.getContext("2d");
	if(ctx){
		supportcan=1;
	}
}

if(supportcan==0){
	var fhtml=getel("fallback").innerHTML;
	if(!fhtml){
		if(history.back){
			history.back();
		}else if(history.go){
			history.go(-1);
		}else if(go){
			go(-1);
		}else{
			alert("Try going back to the previous page or perhaps using the other version instead, or disable JavaScript and load this page again.");
		}
	}else{
		getel("spyn").innerHTML=fhtml;
	}
	if(typeof ctx=="undefined")var ctx={canvas:canv,drawImage:function(){},beginPath:function(){},moveTo:function(){},lineTo:function(){},fill:function(){},stroke:function(){}};
}

/* The above code is an abomination, but it is a feeble and halfhearted attempt at implementing Flash fallback when Canvas refuses to work. Forgive me. */

var sounds=new Array();
var soundProgress=0,soundCount=0;
var uagent=new String(navigator.userAgent);
var prot=(new String(location.href)).split(':')[0].toLowerCase();

if(!webview){
	try{
		var audio=new Audio();
		if(audio.canPlayType('audio/mpeg').replace(/no/i,'')!=''&&uagent.indexOf('Chrome')<=0){
			audio.useType=1;
		}else{
			audio.useType=2;
		}
	}catch(e){
		var audio=new Object();
		audio.useType=0;
	}
}else{
	var audio=new Object();
	audio.useType=0;
}

if(audio.useType==2&&uagent.indexOf('Iron')>0){
	var isIron=true;
}else{
	var isIron=false;
}

if(isIron&&!confirm('If you are using SRWare Iron, enabling audio may cause a crash.\nEnable audio?'))audio.useType=0;

try{
	var actx=new (window.AudioContext||window.webkitAudioContext)();
	var gotWebAudio=true;
}catch(e){
	var gotWebAudio=false;
}

if(gotWebAudio&&(prot=='http'||prot=='https')&&audio.useType>0&&!webview){
	var usingWebAudio=true;

	audio.loadMP3OGG=function(a_file1,a_file2){
		soundCount++;

		var a_result=new Object();
		a_result.loaded=false;
		a_result.evalstring='';
		a_result.loop=false;
		a_result.source=null;
		a_result.play=function(){
			var asrc=actx.createBufferSource();
			asrc.buffer=a_result.buffer;
			asrc.connect(actx.destination);
			asrc.loop=a_result.loop;
			a_result.source=asrc;
			try{
				if(asrc.start){
					asrc.start(0);
				}else{
					asrc.noteOn(0);
				}
			}catch(e){
				/* do nothing */
			}
		}
		a_result.pause=function(){
			var asrc=a_result.source;
			try{
				if(asrc.stop){
					asrc.stop(0);
				}else{
					asrc.noteOff(0);
				}
			}catch(e){
				/* do nothing */
			}
		}

		if(audio.useType==1){
			var url=a_file1;
		}else{
			var url=a_file2;
		}

		var req=new XMLHttpRequest();
		req.open('GET',url,true);
		req.responseType='arraybuffer';

		req.onerror=function(){
			if(a_result.loaded==false){
				a_result.buffer=null;
				a_result.loaded=true;
				soundProgress++;
			}
		}
		req.onload=function(){
			try{
				actx.decodeAudioData(req.response,function(buffer){
					if(buffer){
						if(a_result.loaded==false){
							a_result.buffer=buffer;
							a_result.loaded=true;
							soundProgress++;
						}
						var cont=a_result;
						eval(cont.evalstring);
						a_result.evalstring='';
					}else{
						req.onerror();
					}
				});
			}catch(e){
				req.onerror();
			}
		}
		try{
			req.send(null);
		}catch(e){
			req.onerror();
		}

		return a_result;
	}
}else{
	var usingWebAudio=false;

	audio.loadMP3OGG=function(a_file1,a_file2){
		soundCount++;

		if(audio.useType==0){
			var a_result=new Object();
		}else{
			var a_result=new Audio();
		}

		a_result.loaded=false;

		a_result.evalstring='';

		if(audio.useType>0){
			a_result.addEventListener('loadeddata',function(){
				if(this.loaded==false){
					this.loaded=true;
					soundProgress++;
				}
				eval(this.evalstring);
				this.evalstring='';
			},false);
		}

		if(audio.useType==1){
			a_result.src=a_file1;
		}else if(audio.useType==2){
			a_result.src=a_file2;
		}else{
			a_result.play=function(){}
			a_result.pause=function(){}
			if(a_result.loaded==false){
				a_result.loaded=true;
				soundProgress++;
			}
		}

		return a_result;
	}
}

if(!webview){
	var webview=new Object();
	webview.loadsound=function(sndfile){
		return audio.loadMP3OGG(sndfile.replace(/.ogg/i,'.mp3'),sndfile.replace(/.mp3/i,'.ogg'));
	}
	webview.playsound=function(snd){
		snd.loop=false;
		snd.currentTime=0;
		snd.play();
	}
	webview.loopsound=function(snd){
		snd.loop=true;
		snd.play();
	}
	webview.stopsound=function(snd){
		snd.pause();
		snd.currentTime=0;
	}
}

function loadSound(sndfile,sndnum){
	sounds[sndnum]=webview.loadsound(sndfile);
}

function playSound(sndnum){
	var snd=sounds[sndnum];
	if(snd.loaded !== 'undefined' && snd.loaded == false){
		if(usingWebAudio){
			snd.evalstring+='cont.loop=false;cont.play();';
		}else{
			snd.evalstring+='this.loop=false;this.currentTime=0;this.play();';
		}
	}else{
		webview.playsound(snd);
	}
}

function loopSound(sndnum){
	var snd=sounds[sndnum];
	if(snd.loaded !== 'undefined' && snd.loaded == false){
		if(usingWebAudio){
			snd.evalstring+='cont.loop=true;cont.play();';
		}else{
			snd.evalstring+='this.loop=true;this.play();';
		}
	}else{
		webview.loopsound(snd);
	}
}

function stopSound(sndnum){
	var snd=sounds[sndnum];
	if(snd.loaded !== 'undefined' && snd.loaded == false){
		if(usingWebAudio){
			snd.evalstring+='cont.pause();';
		}else{
			snd.evalstring+='this.pause();this.currentTime=0;';
		}
	}else{
		webview.stopsound(snd);
	}
}

function soundExist(sndnum){
	var snd=sounds[sndnum];
	if(snd !== 'undefined' && snd){
		return true;
	}else{
		return false;
	}
}

/* ------------------------------------------------------------------ */

var image=new Object();
image.progress=0;
image.count=0;

image.loadAny=function(i_file){
	image.count++;

	var i_result=new Image();

	i_result.loaded=false;

	i_result.onload=function(){
		if(this.loaded==false){
			this.loaded=true;
			image.progress++;
		}
	}

	i_result.src=i_file;

	if(i_result.complete==true&&i_result.loaded==false){
		i_result.loaded=true;
		image.progress++;
	}

	return i_result;
}

var sw=canv.width;
var sh=canv.height;
var aspc=sh/sw;
var rx=0,ry=0,rw=0,rh=0;

var mouseclick=false;
var mousex=0.0,mousey=0.0;

function rescale(){
	var destw=window.innerWidth;
	var desth=window.innerHeight;
	if(desth / destw > aspc){
	    /* tall */
	    rw = destw;
	    rh = rw * aspc;
	    rx = 0;
	    ry = (desth - rh) / 2;
	}else{
	    /* wide */
	    rh = desth;
	    rw = rh / aspc;
	    rx = (destw - rw) / 2;
	    ry = 0;
	}

	canv.style.left=rx+'px';
	canv.style.top=ry+'px';
	canv.style.width=rw+'px';
	canv.style.height=rh+'px';
}

rescale();

window.onresize=function(){rescale();}

function touchHandler(event){

	var touches = event.changedTouches,first = touches[0],type = '';

	switch(event.type){

		case 'touchstart':
			type = 'mousedown';
		break;

		case 'touchmove':
			type='mousemove';
		break;

		case 'touchend':
			type='mouseup';
		break;

		default:
		return;

	}

	/*
	initMouseEvent(type, canBubble, cancelable, view, clickCount, 
	screenX, screenY, clientX, clientY, ctrlKey, 
	altKey, shiftKey, metaKey, buttonNumber, relatedTarget);
	*/

	var simulatedEvent = document.createEvent('MouseEvent');
	simulatedEvent.initMouseEvent(type, true, true, window, 1, 
	first.screenX, first.screenY, first.clientX, first.clientY,
	false, false, false, false, 0, null);

	first.target.dispatchEvent(simulatedEvent);
	event.preventDefault();

}

document.addEventListener('touchstart', touchHandler, true);
document.addEventListener('touchmove', touchHandler, true);
document.addEventListener('touchend', touchHandler, true);
document.addEventListener('touchcancel', touchHandler, true);

document.onmousedown=function(evt){
	if(!evt)evt=window.event;
	mousex=(evt.clientX-rx)*sw/rw;
	mousey=(evt.clientY-ry)*sh/rh;
	mouseclick=true;
}

document.onmouseup=function(evt){
	if(!evt)evt=window.event;
	mousex=(evt.clientX-rx)*sw/rw;
	mousey=(evt.clientY-ry)*sh/rh;
	mouseclick=false;
}

document.onmousemove=function(evt){
	if(!evt)evt=window.event;
	mousex=(evt.clientX-rx)*sw/rw;
	mousey=(evt.clientY-ry)*sh/rh;
}


/* ------------------------------------------------------------------ */

function fillRGBA(red,green,blue,alpha){
	ctx.fillStyle='rgb('+red+','+green+','+blue+')';
	ctx.globalAlpha=alpha/255.0;
}

function strokeRGBA(red,green,blue,alpha){
	ctx.strokeStyle='rgb('+red+','+green+','+blue+')';
	ctx.globalAlpha=alpha/255.0;
}

function setAlpha(alpha){
	ctx.globalAlpha=alpha/255.0;
}

function superText(txt,posx,posy,align,size){
	ctx.textAlign=align;
	ctx.font=size*0.894+'px sans-serif';
	ctx.textBaseline='top';
	var txtlines=txt.split(/[\n\r]/g);
	for(var i=0;i<txtlines.length;i++){
		ctx.fillText(txtlines[i],posx,size*i+posy);
	}
}

function cancelMouseClick(){
	mouseclick=false;
}

(function(){
window.console={};
window.console.memory={};
var funcs=['assert','count','debug','dir','dirxml','error','exception','group',
'groupCollapsed','groupEnd','info','log','markTimeline','profile','profileEnd',
'time','timeEnd','trace','warn'];
for(var i=0;i<funcs.length;i++){
window.console[funcs[i]]=function(){};
}
window.console.log.apply=function(){};
})();